## libxmlada 3.0

=== schema/test/Makefile ===
.PHONY: tests old new force

tests: all new

all:
	-@./test_date_time
	-@./testnumbers	

old:
	@./testsuite

new:
	@./schematest > schematest.tmp.out
	-@dos2unix schematest.tmp.out
	@diff -c schematest.out schematest.tmp.out
force:

## libxmlada 3.2

=== schema/test/Makefile ===
.PHONY: tests old new force

tests: all new

all:
	-@./test_date_time
	-@./testnumbers	

old:
	@./testsuite

new:
	@./testsuite -a
	@./schematest > schematest.tmp.out
	@tr -d '\r' < schematest.tmp.out > schematest.tmp
	@diff -c schematest.out schematest.tmp
force:

## libxmlada 4.1

=== dom/test/Makefile ===
tests: force
	@./testxml -auto > test_xml.tmp_out
	-@tr -d '\r' < test_xml.tmp_out > test_xml.out
	@ diff test_xml.expected test_xml.out > test_xml.diff
	@cat test_xml.diff
	@cd act_testsuite; ./run > test_act.out

force:

=== schema/test/Makefile ===
.PHONY: tests new force

# Set this to "acroread" if you have it installed on your machine
PDFVIEWER=okular

tests: all new

all:
	-@./test_date_time
	-@./testnumbers	

# Do not hide Passed tests, since we want to compare error messages
# The W3C testsuite is meant to test XSD 1.0, so we have to configure the parser
# in the appropriate mode.
new:
	-@./testsuite > test_act_schema.tmp_out 2>&1
	-@tr -d '\r' < test_act_schema.tmp_out > test_act_schema.out
	-@diff -c test_act_schema.expected test_act_schema.out > test_act_schema.diff
	@cat test_act_schema.diff
	-@./schematest --xsd10 > test_schema.tmp_out
	-@tr -d '\r' < test_schema.tmp_out > test_schema.out
	-@diff -u test_schema.expected test_schema.out > test_schema.diff
	@cat test_schema.diff

# Explain how the various errors are split:
errors:
	@egrep "^  -" test_schema.expected | perl -pi -e  's/\S+:\d+:\d+://g; s/^\s+//' | sort | uniq -c | sort -n

# Display the NFA used for validation. This requires the external tool
# "graphviz" to be installed on your machine.
# To use:
#     ./testschema -xsd <xsdfile> -debug > foo
#     make dot_schema
# Note that this does not include the XSD metaschema (which is a big NFA, that
# pdf viewers have trouble to display). Substitute "tail" for "head" if you
# still want to see it

LOGFILE=foo

dot_schema:
	grep digraph ${LOGFILE} | tail -1 > ${LOGFILE}.dot
	dot -O -Tpdf ${LOGFILE}.dot
	${PDFVIEWER} ${LOGFILE}.dot.pdf

clean_dot:
	${RM} ${LOGFILE} ${LOGFILE}.dot ${LOGFILE}.dot.pdf

force:

=== debian/changelog ===
libxmlada (4.1-4) unstable; urgency=low

  * Conflics -> Breaks for previous versions per Ada policy.
    Specify versions for Breaks and Replaces (old package split).
  * rules: switch to dh_ada_library.
  * tests: updated to latest autopkg specification (cosmetic).
  * Removed work-around for GCC bug on ia64 (unreproducible with 4.6).

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 29 Aug 2013 04:21:02 +0200

libxmlada (4.1-3) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.
  * Switch to debhelper 9 dh driver.
  * Standards-Version 3.9.4. No more DM-Upload-Allowed, copyright file format.
  * Rely on snippets provided by recent dpkg-dev and dh-ada-library to
    deal with architecture, hardening, noopt and parallel options.
  * Install examples. Use one as run-time test of dynamic linking.
  * Added libxmlada-doc.doc-base.xmlada, watch (informative only).
  * debian/patches/texinfo5.diff:  Closes: #713299.
  * xmlada-config,.gpr: generated, replace usr/lib with multiarch path.
  * Do not compress examples, install TODO in the -doc package.
  * Added myself to uploaders.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 16 Aug 2013 02:12:43 +0200

libxmlada (4.1-2) unstable; urgency=low

  * debian/patches/xmlada-config.patch: bump version number.
    Closes: #661593.
  * debian/control: remove references to ada-compiler.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 28 Feb 2012 19:59:42 +0100

libxmlada (4.1-1) unstable; urgency=low

  [Xavier Grave]
  * New upstream version 4.1
  * add get-orig-source in debian/rules
  * Package renamings pursuant to Debian Policy for Ada:
    libxmlada3.2     -> libxmlada4.1
    libxmlada3.2-dev -> libxmlada4.1-dev
    libxmlada3.2-dbg -> libxmlada4.1-dbg
  
  [Ludovic Brenta]
  * debian/control (Architecture): any.
    (Uploaders): add Xavier.
    (DM-Upload-Allowed): yes.
    (Standards-Version): move to 3.9.2 with no changes required.
    (Multi-Arch): same.
    (Build-Depends): debhelper (>= 8.1.3).
  * debian/rules: install the shared and static libs in the multiarch
    directory.
  * debian/compat: bump to 8.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue,  6 Sep 2011 11:30:15 +0200

libxmlada (3.2-5) unstable; urgency=low

  * debian/control (*-dev): depend on gnat, ada-compiler.
    (*-doc, *-dbg): suggest gnat, gnat-4.4, ada-compiler.
    (Standards-Version): bump to 3.8.4 with no changes required.
    (VCS-Browser, VCS-Mtn): new.
    (Architecture): add armel  Closes: #568447.
  * debian/rules: extract the aliversion and soversion from
    debian/changelog.
  * Add support for building architecture-dependent and
    architecture-independent packages separately (i.e. dpkg-buildpackage
    -A, -B).
    debian/rules (binary): split into binary-arch and binary-indep.
    debian/control (Build-Depend-Indep): new, move some dependencies
    from Build-Depend.

  [Nicolas Boulenguez]
  * debian/rules (libxmlada$(ALIVERSION)-dev): Removed obsolete and empty
    doc directory.

 -- Ludovic Brenta <lbrenta@debian.org>  Wed, 16 Jun 2010 20:51:18 +0200

libxmlada (3.2-4) unstable; urgency=medium

  * debian/build_xmlada.gpr: work around a ia64-only compiler bug.
    Allows the package to build on ia64.
  * debian/rules (binary-indep): do not compress PDF files, they are
    already compressed internally.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun, 13 Dec 2009 15:37:21 +0100

libxmlada (3.2-3) unstable; urgency=low

  [Xavier Grave]
  * debian/rules (libxmlada$(ALIVERSION)-dev): s/SONAME/SOVERSION/;
    fixes a bug.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue,  1 Dec 2009 22:04:15 +0100

libxmlada (3.2-2) unstable; urgency=low

  * debian/control (libxmlada-doc): conflict with old versions of
    the -dev package, they used to contain the documentation.
    Closes: #557497.
  * debian/rules (libxmlada-doc): also install the changelog.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 24 Nov 2009 00:37:12 +0100

libxmlada (3.2-1) unstable; urgency=low

  * New upstream version taken from Subversion revision 150712.
  * debian/control (Build-Depends, Depends): transition to gnat-4.4.
    (Architectures): remove alpha due to http://gcc.gnu.org/PR42073.
    (libxmlada-doc): new package, Architecture: all.
    Package renamings:
    - libxmlada-dev to libxmlada3.2-dev
      with Conflicts: and Replaces:, per Debian Policy for Ada
      [http://people.debian.org/~lbrenta/debian-ada-policy.html].
    - libxmlada3{,-dbg} to libxmlada3.2{,-dbg}
  * build_xmlada.gpr, xmlada-config.gpr: move to debian/.
  * debian/README.Debian: remove, outdated.

 -- Ludovic Brenta <lbrenta@debian.org>  Thu, 19 Nov 2009 23:06:09 +0100

libxmlada (3.0-6) unstable; urgency=low

  * debian/control (Architecture): add kfreebsd-amd64.  Closes: #542416.
    (Standards-Version): bump to 3.8.3.
    (Depends): s/source:Version/binary:Version/g.
  * debian/rules, debian/control (libxmlada3-dbg): introduce a new
    package containing the detached debugging symbols.
  * build_xmlada.gpr: always build with -g.
  * patches: move to debian/patches.  Make the patches compliant with
    "quilt refresh -p ab".  Closes: #485098.
  * debian/rules: become compliant with source format 3.0 (quilt).
    (clean): s/dh_clean -k/dh_prep/.
    (libxmlada.so.3): gatmake knows about -fPIC when Library_Kind is
    "dynamic", so do not pass it explicitly.
  * debian/compat: bump to 7.
  * debian/xmlada.gpr: turn into a proper library project file.
    Closes: #522031.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 12 Sep 2009 12:54:47 +0200

libxmlada (3.0-5) unstable; urgency=low

  * Tighten build-dependency on gnat-4.3 due to bug fixes in libgnat that
    affect the .ali files.
  * Add Support for ppc64 in debian/control.
  * xmlada-config.1: correct a syntax error detected by lintian; simplify.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun,  1 Jun 2008 15:41:26 +0200

libxmlada (3.0-4) unstable; urgency=low

  [Andreas Metzler]


=== debian/control ===
Source: libxmlada
Priority: optional
Section: libdevel
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-4.6, dh-ada-library (>= 5.4)
# dh-ada-library << 5.4 introduce symlinks in doc dirs.
Build-Depends-Indep: texinfo, texlive-generic-recommended,
 texlive-fonts-recommended, texlive-latex-base
Standards-Version: 3.9.4
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libxmlada
Vcs-Mtn: www.ada-france.org org.debian.libxmlada
XS-Testsuite: autopkgtest
Homepage: https://libre.adacore.com/libre

Package: libxmlada4.1-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Breaks: libxmlada-dev (<< 3.2-1)
Replaces: libxmlada-dev (<< 3.2-1)
Recommends: libxmlada-doc
Description: XML/Ada, a full XML suite for Ada programmers
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the static libraries, documentation, and Ada
 specification files.  Install it if you want to develop XML
 applications in Ada.

Package: libxmlada-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Breaks: libxmlada-dev (<< 3.2-1)
Replaces: libxmlada-dev (<< 3.2-1)
Suggests: gnat, gnat-4.6
Description: XML/Ada, a full XML suite for Ada programmers (documentation)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the documentation in text, PDF, info and HTML.

Package: libxmlada4.1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the runtime shared library.

Package: libxmlada4.1-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${ada:Depends}, ${misc:Depends}
Recommends: ${ada:Recommends}
Suggests: ${ada:Suggests}
Description: XML/Ada, a full XML suite for Ada programmers (debugging symbols)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the detached debugging symbols for the runtime
 shared library.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for XML/Ada in Debian.
# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013      Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

ADAFLAGS += -gnatafno -gnatVa -gnatwa

ALIVERSION := $(shell sed -n -r 's/^Package: libxmlada(.*)-dev$$/\1/p' debian/control)
SOVERSION := $(shell sed -n -r 's/^Package: libxmlada([^-]+)$$/\1/p' debian/control)
soname := libxmlada.so.$(SOVERSION)

mtnbase := base_debian.db
mtnversion := bc73f0c0f1fe677f059a57ef1ccad9e2ca5160a9
branch := com.adacore.xmlada.debian
orig_dir := libxmlada_$(ALIVERSION).orig
orig_tgz := libxmlada_$(ALIVERSION).orig.tar.gz

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
 build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

# Ignore upstream build system.
override_dh_auto_configure:
override_dh_auto_build-arch:
override_dh_auto_build-indep:
override_dh_auto_install:
override_dh_auto_test:
override_dh_auto_clean::

######################################################################
get-orig-source:
	if [ ! -e ../$(mtnbase) ]; then \
		mtn -d../$(mtnbase) db init; \
	fi; \
	mtn -d../$(mtnbase) -k "" pull www.ada-france.org '$(branch)'; \
	cd .. && \
	mtn -d$(mtnbase) co -r$(mtnversion) -b$(branch) $(orig_dir) && \
	rm -rf $(orig_dir)/_MTN $(orig_dir)/.*ignore&& \
	tar czf $(orig_tgz) $(orig_dir) && \
	rm -r $(orig_dir)

######################################################################
override_dh_auto_build-arch:
	gnatmake $(BUILDER_OPTIONS) -Pdebian/build_xmlada -Xkind=static \
          $(foreach f,ADAFLAGS,"-X$(f)=$($(f))")
	gnatmake $(BUILDER_OPTIONS) -Pdebian/build_xmlada -Xkind=dynamic \
          $(foreach f,ADAFLAGS LDFLAGS soname,"-X$(f)=$($(f))")

override_dh_auto_clean::
	rm -f $(foreach d, lib obj, \
              $(foreach k, dynamic static, \
              debian/build_$(d)_$(k)/*))

######################################################################
DOCS := $(foreach ext,html info pdf txt,docs/xmlada.$(ext))
override_dh_auto_build-indep: $(DOCS)

docs/xmlada.html: docs/xml.texi
	cd docs; makeinfo --html --no-split $(notdir $<) -o $(notdir $@)

docs/xmlada.info: docs/xml.texi
	cd docs; makeinfo --no-split $(notdir $<$) -o $(notdir $@)

docs/xmlada.pdf: docs/xml.texi
	cd docs; texi2pdf $(notdir $<) -o $(notdir $@)

docs/xmlada.txt: docs/xml.texi
	cd docs; makeinfo --plaintext --no-split $(notdir $<) -o $(notdir $@)

override_dh_auto_clean::
	rm -f $(DOCS)
	rm -f $(foreach ext,aux cp cps pg ky tp vr fn log pdf toc,docs/xml.$(ext))

######################################################################
XMLADA_CONFIG := debian/xmlada-config

override_dh_auto_build-arch: $(XMLADA_CONFIG)
$(XMLADA_CONFIG): %: %.sed
	sed $< $(foreach v,DEB_HOST_MULTIARCH SOVERSION \
          ,-e 's/@$(v)@/$($(v))/g') > $@
override_dh_auto_clean::
	rm -f $(XMLADA_CONFIG)

######################################################################

override_dh_installexamples:
	dh_installexamples --all
	find debian -path "debian/libxmlada-doc/usr/share/doc/libxmlada-doc/examples/*/.cvsignore" -delete

override_dh_compress:
	dh_compress --package=libxmlada-doc \
           --exclude=.adb --exclude=.ads --exclude=.gpr \
           --exclude=.xml --exclude=.xsd
	dh_compress --remaining-packages

######################################################################

RUN_TESTS_TMP := libxmlada-run-tests-XXXXXXXXXX

run-tests:
	ADTTMP=`mktemp --tmpdir --directory $(RUN_TESTS_TMP)` && \
        ADTTMP=$$ADTTMP sh debian/tests/link-with-shared 2> $$ADTTMP/stderr; \
        status=$$?; cat $$ADTTMP/stderr; \
        if test $$status != 0; then \
          echo "Test failed: non zero exit status ($$status)."; \
        elif test -s $$ADTTMP/stderr; then \
          echo "Test failed: activity on stderr."; \
        fi; \
        rm -f -r $$ADTTMP

=== debian/tests/control ===
Tests: link-with-shared

## libxmlada 4.4.2014

=== dom/test/Makefile ===
tests: force
	@./testxml -auto > test_xml.tmp_out
	-@tr -d '\r' < test_xml.tmp_out > test_xml.out
	@diff test_xml.expected test_xml.out > test_xml.diff
	@cat test_xml.diff
	@if [ -d act_testsuite ]; then cd act_testsuite; ./run > test_act.out; else echo "DOM act_test_suite directory not found (expected)"; fi

force:

=== sax/test/Makefile ===
tests: force
	@./teststate > test_sax.out
	@cat test_sax.out

force:

=== schema/test/Makefile ===
--- 
+++ 
@@ -13,10 +13,8 @@
 # The W3C testsuite is meant to test XSD 1.0, so we have to configure the parser
 # in the appropriate mode.
 new:
-	-@./testsuite > test_act_schema.tmp_out 2>&1
-	-@tr -d '\r' < test_act_schema.tmp_out > test_act_schema.out
-	-@diff -c test_act_schema.expected test_act_schema.out > test_act_schema.diff
-	@cat test_act_schema.diff
+	-@./testsuite 
+	@#-valgrind --leak-resolution=high --leak-check=full ./schematest --xsd10 > test_schema.tmp_out
 	-@./schematest --xsd10 > test_schema.tmp_out
 	-@tr -d '\r' < test_schema.tmp_out > test_schema.out
 	-@diff -u test_schema.expected test_schema.out > test_schema.diff

=== unicode/test/Makefile ===
tests: force
	@./test_unicode > test_unicode.out
	@cat test_unicode.out

force:

=== debian/changelog ===
libxmlada (4.4.2014-1build1) utopic; urgency=medium

  * No change rebuild for gnat-4.9.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 21 Aug 2014 19:55:56 +0200

libxmlada (4.4.2014-1) unstable; urgency=medium

  * New upstream release GPL 2014 (between 4.4 and 4.5).
    SO version does not change, but ALI version does. Per Ada policy,
    dev package is renamed and Breaks/Replaces with previous ones

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 03 Aug 2014 20:27:26 +0200

libxmlada (4.4.0puregpl-1) unstable; urgency=medium

  * The actual license does not grant the GCC Runtime Library Exception.
    Switched back to a branch for the orig archive, see debian/README.source.
    Obsoletes: license patch, override removing cvs-ignore.
  * patches/compile_with_4.6.diff: not needed anymore with gnat-4.9.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 02 May 2014 17:52:44 +0200

libxmlada (4.4.0-1) unstable; urgency=medium

  * New upstream release.
  * License clarified: GPL-3+ with GCC Runtime Library Exception.
  * Docs now formatted by sphinx. Symlink embedded javascript when possible.
  * xmlada-config relies on upstream configure again.
  * rules: run-tests target obsoleted by sadt from devscripts.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 01 May 2014 13:24:20 +0200

=== debian/control ===
--- 
+++ 
@@ -2,24 +2,28 @@
 Priority: optional
 Section: libdevel
 Maintainer: Ludovic Brenta <lbrenta@debian.org>
-Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
+Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
- gnat, gnat-4.6, dh-ada-library (>= 5.4)
+ autotools-dev, autoconf,
+# Rules regenerate all the configure stuff.
+ gnat, gnat-4.9, dh-ada-library (>= 5.4)
 # dh-ada-library << 5.4 introduce symlinks in doc dirs.
-Build-Depends-Indep: texinfo, texlive-generic-recommended,
- texlive-fonts-recommended, texlive-latex-base
-Standards-Version: 3.9.4
+Build-Depends-Indep: python-sphinx,
+ texlive-fonts-recommended,
+ texlive-latex-extra,
+ texlive-latex-recommended
+Standards-Version: 3.9.5
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libxmlada
 Vcs-Mtn: www.ada-france.org org.debian.libxmlada
 XS-Testsuite: autopkgtest
 Homepage: https://libre.adacore.com/libre
 
-Package: libxmlada4.1-dev
+Package: libxmlada5-dev
+Breaks: libxmlada4.4.0-dev
+Replaces: libxmlada4.4.0-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
-Breaks: libxmlada-dev (<< 3.2-1)
-Replaces: libxmlada-dev (<< 3.2-1)
 Recommends: libxmlada-doc
 Description: XML/Ada, a full XML suite for Ada programmers
  XML/Ada is a set of modules that provide a simple manipulation of XML
@@ -37,10 +41,10 @@
 Package: libxmlada-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
 Breaks: libxmlada-dev (<< 3.2-1)
 Replaces: libxmlada-dev (<< 3.2-1)
-Suggests: gnat, gnat-4.6
+Suggests: gnat
 Description: XML/Ada, a full XML suite for Ada programmers (documentation)
  XML/Ada is a set of modules that provide a simple manipulation of XML
  streams. It supports the whole XML 1.0 specifications, and can parse
@@ -50,9 +54,9 @@
  includes a module to manipulate Unicode streams, since this is required
  by the XML standard.
  .
- This package contains the documentation in text, PDF, info and HTML.
+ This package contains the documentation in text, PDF and HTML.
 
-Package: libxmlada4.1
+Package: libxmlada4.4.0
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -69,7 +73,7 @@
  .
  This package contains the runtime shared library.
 
-Package: libxmlada4.1-dbg
+Package: libxmlada-dbg
 Section: debug
 Priority: extra
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# Build script for XML/Ada in Debian.
# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2014 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

ADAFLAGS += -gnatafno -gnatVa

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
 build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

AUTOCONF_AUXILIARY_FILES := \
 config.guess \
 config.sub \
 configure \
 install-sh

override_dh_auto_configure: configure-stamp
configure-stamp: $(addsuffix .backup,$(AUTOCONF_AUXILIARY_FILES))
	dh_auto_configure
	touch $@
# Up-to-date config.[guess|sub] are provided by autotools-dev.
config.guess.backup config.sub.backup: %.backup:
	mv $* $@
	ln -s /usr/share/misc/$*
# configure: generated by autoconf.
configure.backup: %.backup:
	mv $* $@
	autoconf
# install-sh: unused, but configure insists on seeing it.
install-sh.backup: %.backup:
	mv $* $@
	touch $*

override_dh_auto_build-arch:
	gnatmake $(BUILDER_OPTIONS) -Pdebian/build_xmlada -Xkind=static \
          $(foreach f,ADAFLAGS,"-X$(f)=$($(f))")
	gnatmake $(BUILDER_OPTIONS) -Pdebian/build_xmlada -Xkind=dynamic \
          $(foreach f,ADAFLAGS LDFLAGS,"-X$(f)=$($(f))")

override_dh_auto_build-indep:
	$(MAKE) -C docs html latexpdf text SPHINXOPTS=-j$(BUILDER_JOBS)

override_dh_auto_test:

override_dh_auto_install:

# Configure, so that we can assume *.backup and Makefiles exist.
override_dh_auto_clean: configure-stamp
	rm -f $(foreach d, lib obj, \
              $(foreach k, dynamic static, \
              debian/build_$(d)_$(k)/*))
	dh_auto_clean
	for f in $(AUTOCONF_AUXILIARY_FILES); do \
          mv $$f.backup $$f; \
        done

######################################################################
# Policy specifies that get-orig-source may be run outside the source
# tree, so we rely on a temporary directory and hard-code the version.

orig_version    := 4.4.2014
orig_archive    := libxmlada_$(orig_version).orig.tar.xz
orig_tmp_dir    := /tmp/libxmlada_get_orig_source_tmp_dir
# Set this to your own database on the command line if you already
# have a local clone of the upstream branch.
# By default, a temporary database is populated.
orig_mtn_db     := $(orig_tmp_dir)/tmpdb
orig_server     := www.ada-france.org
orig_server_key := f8a11727e8983cf9083c08c6a2acaa27e439dd39
orig_branch     := com.adacore.xmlada.debian
orig_revision   := t:libxmlada-$(orig_version)
orig_directory  := libxmlada-$(orig_version).orig

get-orig-source:
	test ! -e $(orig_archive) # Stop if the archive exists.
	mkdir $(orig_tmp_dir) # Stop if the temp dir exists.
	@echo
	@echo The server key below should be $(orig_server_key).
	@echo
	mtn clone --db=$(orig_mtn_db) mtn://$(orig_server)?$(orig_branch) \
          --branch=$(orig_branch) --revision=$(orig_revision) \
          $(orig_tmp_dir)/$(orig_directory)
	tar -c -J -f $(orig_archive) -C $(orig_tmp_dir) $(orig_directory) \
          --exclude=_MTN --exclude=.mtn-ignore
	rm -f -r $(orig_tmp_dir)
	@echo
	@echo Created $(orig_archive) in the current directory.

######################################################################
override_dh_compress:
	dh_compress --package=libxmlada-doc \
           --exclude=.adb --exclude=.ads --exclude=.gpr \
           --exclude=.xml --exclude=.xsd
	dh_compress --remaining-packages

=== debian/watch ===
# Upstream uses a complicated website making hard to automatically find new
# versions of XML/Ada. See debian/copyright for the URL.

## libxmlada 4.5.2015

=== dom/test/Makefile ===
tests: force
	@./testxml -auto > test_xml.tmp_out
	-@tr -d '\r' < test_xml.tmp_out > test_xml.out
	@diff test_xml.expected test_xml.out > test_xml.diff
	@cat test_xml.diff
	@if [ -d act_testsuite ]; then cd act_testsuite; ./run; else echo "DOM act_test_suite directory not found (expected)"; fi

force:

=== debian/changelog ===
libxmlada (4.5.2015-8) unstable; urgency=medium

  * Build-Depend iftex.sty from texlive-generic-extra. Closes: #830395.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 11 Jul 2016 13:54:06 +0200

libxmlada (4.5.2015-7) unstable; urgency=medium

  [Martin Pitt]
  * Declare that tests/no-project depends on dpkg-dev, GCC. Closes: 823998.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 14 May 2016 16:03:39 +0200

libxmlada (4.5.2015-6) unstable; urgency=medium

  * Upload to unstable.
  * Standards-Versions: 3.9.8 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 25 Apr 2016 23:36:04 +0200

libxmlada (4.5.2015-5) experimental; urgency=medium

  * Add more libraries versions (checked with apt-cudf in pbuilder).

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 18 Apr 2016 21:24:01 +0200

libxmlada (4.5.2015-4) experimental; urgency=medium

  * Select experimental versions >= 6~ of GCC libraries, so that the
    dependency resolver on build daemons manages to install gnat-6.
  * Select gnatgcc in case it differs from gcc.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 17 Apr 2016 10:27:52 +0200

libxmlada (4.5.2015-3) experimental; urgency=medium

  * Rebuild with gnat-6.
  * Implement our own dh-ada-library to break circular build-dependency.
  * Enable all hardening flags, except PIE for the relocatable library.
  * Replace explicit -dbg packages with automatic -dbgsym packages.
  * Update to Standards-Versions 3.9.7 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 09 Mar 2016 00:19:13 +0100

libxmlada (4.5.2015-2) experimental; urgency=medium

  * Arch-only builds should not require sphinx-common.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 30 Oct 2015 19:23:06 +0100

libxmlada (4.5.2015-1) experimental; urgency=medium

  * New upstream release GPL 2015 (between 4.5 and 4.6), built with gnat-5.
    Split libraries, change library and -dev packages versions per Ada policy.
    Avoid projects during build: gnatmake is dropping them, and
    gprbuild would cause a circular build dependency.
    Use Files-Excluded to spare half the size, avoid minified javascript,
    drop Build-Dependency on autotools-dev and autoconf.
  * Freeze the clock for deterministic PDF timestamps.
  * Use dh-sphinxdoc.
  * Patch SO version from debian/rules instead of a static patch.
  * control/Testsuite: obsolete.
  * watch: use Debian redirector to detect next GPL release.
    README.source, find_branchpoint.sh: describe what to do then.
  * Test project, command line and xmlada-config.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 26 Sep 2015 14:51:55 +0200

=== debian/control ===
Source: libxmlada
Priority: optional
Section: libdevel
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
# dpkg-dev: /usr/share/dpkg/default.mk
 gnat, gnat-6,
# gnat-v: /usr/share/ada/debian_packaging-v.mk
Build-Depends-Indep: python-sphinx,
 texlive-fonts-recommended,
# sphinx-doc requires iftex.sty:
 texlive-generic-extra,
 texlive-latex-extra,
# Called in rules for deterministic PDF timestamps.
 faketime,
# Sphinx-common provides dh_sphinxdoc.
 sphinx-common
Standards-Version: 3.9.8
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libxmlada
Vcs-Mtn: www.ada-france.org org.debian.libxmlada
Homepage: https://libre.adacore.com/libre

Package: libxmlada-unicode6-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Recommends: libxmlada-doc
# so all -dev packages indirectly Recommend: -doc.
Description: XML/Ada, a full XML suite for Ada programmers (unicode)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the unicode module.
 .
 It also provides the xmlada-config executable, which may be useful
 with various XML/Ada -dev packages,
# all depending on this one
 and was formerly shipped in libxmlada*-dev.
# But no Conflict: libxmlada5-dev because we Depend: a different gnat.

Package: libxmlada-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Breaks: libxmlada-dev (<< 3.2-1)
Replaces: libxmlada-dev (<< 3.2-1)
Suggests: gnat
Description: XML/Ada, a full XML suite for Ada programmers (documentation)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the documentation in text, PDF and HTML.

Package: libxmlada-dom6-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (dom)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the dom module.

Package: libxmlada-dom4.5.2015
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (dom runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the dom runtime shared library.

Package: libxmlada-input-sources6-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (input sources)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the input sources module.

Package: libxmlada-input-sources4.5.2015
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (input sources runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the input sources runtime shared library.

Package: libxmlada-sax6-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (sax)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the sax module.

Package: libxmlada-sax4.5.2015
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (sax runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the sax runtime shared library.

Package: libxmlada-schema6-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (schema)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the schema module,
 and an xmlada.gpr project importing the whole XML/Ada library.
# inside schema-dev because it Depends: every other -dev package.
# But no Conflict: libxmlada5-dev because we Depend: a different gnat.

Package: libxmlada-schema4.5.2015
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (schema runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the schema runtime shared library.

Package: libxmlada-unicode4.5.2015
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (unicode runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the unicode runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for XML/Ada in Debian.
# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2016 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

GNAT_VERSION := 6
DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
# PIE should only affect the static library.
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

DEB_DATE := $(shell dpkg-parsechangelog -S date)

ADAFLAGS += -gnatafno -gnatVa

# Ignore gnat.adc in top directory.
BUILDER_OPTIONS += -gnatA

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
 build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@

# Rewrite upstream configure/make build system.
.PHONY: $(addprefix override_dh_auto_, \
  configure build-arch build-indep test install clean)

CONFIGURED := xmlada-config
override_dh_auto_build-arch: $(CONFIGURED)
$(CONFIGURED): %: %.in
	sed "\
          s/@PACKAGE_VERSION@/$(DEB_VERSION_UPSTREAM)/g; \
          s/@DEFAULT_LIBRARY_TYPE@/relocatable/g; \
          s%@libdir@%/usr/lib/$(DEB_HOST_MULTIARCH)%g; \
          " $< > $@
# Installation will append once unicode_DEV_PKG has been computed.
override_dh_auto_clean::
	rm -f $(CONFIGURED)

# Rewrite upstream targets without gprbuild or gprclean.
# gnatmake does not support projects anymore, we cannot use xmlada.gpr.
# Also avoid a circular build-dependency between gprbuild and xmlada.

ADS_DIR := usr/share/ada/adainclude
GPR_DIR := usr/share/ada/adainclude
ALI_DIR := usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib
SO_DIR  := usr/lib/$(DEB_HOST_MULTIARCH)
A_DIR   := usr/lib/$(DEB_HOST_MULTIARCH)

grep_pkg = $(shell sed -n '/^Package: \(libxmlada-$(1)\)$$/{s//\1/p;q}' debian/control)

# All libraries built so far will be prepended to that list, for -aI
# -aO and -l options. The order matters for -l, and redundancy does
# not because we link with --as-needed.
LIBS :=

# Imported projects and -dev packages, unsorted subset of LIBS.
unicode_LIBS       :=
input_sources_LIBS := unicode
sax_LIBS           := unicode input_sources
dom_LIBS           := sax unicode
schema_LIBS        := dom sax unicode

define library_template

  $(library)_DEV_PKG := $(call grep_pkg,$(subst _,-,$(library))[0-9.]\+-dev)
  $(library)_LIB_PKG := $(call grep_pkg,$(subst _,-,$(library))[0-9.]\+)

  # Build dynamic library.
  override_dh_auto_build-arch: $(library)/lib/relocatable/libxmlada_$(library).so.$(DEB_VERSION_UPSTREAM)
  $(library)/lib/relocatable/libxmlada_$(library).so.$(DEB_VERSION_UPSTREAM):
	gnatmake -c $(library)/*.ad[bs] -D $(library)/obj/relocatable \
          $(BUILDER_OPTIONS) \
          $(foreach l,$(LIBS),-aI$(l) -aO$(l)/obj/relocatable) \
          -cargs $(ADAFLAGS) -fPIC
	gnatgcc -shared \
          -o $(library)/lib/relocatable/libxmlada_$(library).so.$(DEB_VERSION_UPSTREAM) \
          -Wl,-soname,libxmlada_$(library).so.$(DEB_VERSION_UPSTREAM) \
          $(LDFLAGS) \
          $(library)/obj/relocatable/*.o $(foreach l,$(LIBS),-L$(l)/lib/relocatable -lxmlada_$(l)) -lgnat-$(GNAT_VERSION)

  # Create development link so that the other libraries may link with it.
  override_dh_auto_build-arch: $(library)/lib/relocatable/libxmlada_$(library).so
  $(library)/lib/relocatable/libxmlada_$(library).so:
	ln -s libxmlada_$(library).so.$(DEB_VERSION_UPSTREAM) $(library)/lib/relocatable/libxmlada_$(library).so

  # Build static library.
  override_dh_auto_build-arch: $(library)/obj/static/libxmlada_$(library).a
  $(library)/obj/static/libxmlada_$(library).a:
	gnatmake -c $(library)/*.ad[bs] -D $(library)/obj/static \
          $(BUILDER_OPTIONS) \
          $(foreach l,$(LIBS),-aI$(l) -aO$(l)/obj/static) \
          -cargs $(ADAFLAGS) -fPIE
	ar rc $(library)/obj/static/libxmlada_$(library).a $(library)/obj/static/*.o
	ranlib $(library)/obj/static/libxmlada_$(library).a

  LIBS := $(library) $(LIBS)

  override_dh_install::
  # dynamic library
	dh_install --package=$$($(library)_LIB_PKG) \
	  $(library)/lib/relocatable/libxmlada_$(library).so.$(DEB_VERSION_UPSTREAM) \
	  $(SO_DIR)
  # static library
	dh_install --package=$$($(library)_DEV_PKG) \
	  $(library)/obj/static/libxmlada_$(library).a $(A_DIR)
  # development symbolic link
	dh_link --package=$$($(library)_DEV_PKG) \
	  $(SO_DIR)/libxmlada_$(library).so.$(DEB_VERSION_UPSTREAM) \
	  $(SO_DIR)/libxmlada_$(library).so
  # ALI files
	dh_install --package=$$($(library)_DEV_PKG) \
	  $(library)/obj/relocatable/*.ali $(ALI_DIR)/xmlada_$(library)
  # Sources
	dh_install --package=$$($(library)_DEV_PKG) \
	  $(library)/*.ad[bs] $(ADS_DIR)/xmlada_$(library)
  # Substitution variables for the control file.
	echo 'ada:Depends=gnat, gnat-$(GNAT_VERSION), \
	  $$(foreach l,$$($(library)_LIBS),$$($$(l)_DEV_PKG) (= $$$${binary:Version}),)$$($(library)_LIB_PKG)' \
	  >> debian/$$($(library)_DEV_PKG).substvars

  override_dh_auto_clean::
	rm -f $(library)/lib/relocatable/*
	rm -f $(library)/obj/relocatable/*
	rm -f $(library)/obj/static/*

  # Externally built project installed for end users.
  override_dh_auto_build-arch: debian/xmlada_$(library).gpr
  debian/xmlada_$(library).gpr: debian/template.gpr
	sed ' \
	  s/@IMPORTS@/$$(foreach d,$$($(library)_LIBS),with "xmlada_$$(d).gpr";\n)/; \
	  s/\n with/\nwith/; \
	  $(foreach v,library SO_DIR ADS_DIR ALI_DIR,s|@$(v)@|$($(v))|;) \
	  ' $$< > $$@
  override_dh_install::
	dh_install --package=$$($(library)_DEV_PKG) \
	  debian/xmlada_$(library).gpr $(GPR_DIR)
  override_dh_auto_clean::
	rm -f debian/xmlada_$(library).gpr

endef
$(foreach library,unicode input_sources sax dom schema,$(eval $(call library_template)))

# Freeze the clock for deterministic PDF timestamps. The faketime API
# does not allow an explicit time zone, introducing an implicit
# dependency on its local value.
DEB_DATE_FAKETIME := $(shell date "+%F %T" -d "$(DEB_DATE)")
# Upstream docs target does not generate text output.
override_dh_auto_build-indep:
 # Freeze the clock for deterministic PDF timestamps.
	faketime -f "$(DEB_DATE_FAKETIME)" \
	$(MAKE) -C docs html latexpdf text SPHINXOPTS=-j$(BUILDER_JOBS)
override_dh_auto_clean::
	rm -fr docs/_build

# Compatibility project, importing all XMLAda libraries.
XMLADA_GPR := debian/xmlada.gpr
override_dh_auto_build-arch: $(XMLADA_GPR)
$(XMLADA_GPR): distrib/xmlada.gpr
	sed s/xmlada_input/xmlada_input_sources/ $< > $@
override_dh_install::
	dh_install --package=$(schema_DEV_PKG) $(XMLADA_GPR) $(GPR_DIR)
override_dh_auto_clean::
	rm -f $(XMLADA_GPR)

# Remaining install tasks.
.PHONY: override_dh_install
override_dh_install::
	dh_install --package=$(unicode_DEV_PKG) xmlada-config usr/bin
	dh_install --remaining-packages

######################################################################
# Mimic 'dh --with sphinxdoc', but without adding sphinx-common to
# Build-Depends for arch-only builds.
.PHONY: override_dh_installdocs-indep
override_dh_installdocs-indep:
	dh_installdocs -i
	dh_sphinxdoc

######################################################################
.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --package=libxmlada-doc \
           --exclude=.adb --exclude=.ads --exclude=.gpr \
           --exclude=.xml --exclude=.xsd

=== debian/tests/control ===
Tests: link-with-shared xmlada-config

Tests: no-project
Depends: @, dpkg-dev, gcc

=== debian/watch ===
version=3
opts=filenamemangle=s/^.*download=//,dversionmangle=s/^.*\.// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/xmlada \
.*xmlada-gpl-(\d{4})-src\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

# Major and minor versions are set manually, see README.source.
